# SQL Manager 2005 for MySQL Lite 3.5.0.1
# ---------------------------------------
# Host     : localhost
# Port     : 3306
# Database : cvsweb


/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES gbk */;

SET FOREIGN_KEY_CHECKS=0;

CREATE DATABASE `cvsweb`
    CHARACTER SET 'gbk'
    COLLATE 'gbk_chinese_ci';

USE `cvsweb`;

#
# Structure for the `userinfo` table : 
#

CREATE TABLE `userinfo` (
  `ID` int(11) NOT NULL,
  `NAME` varchar(100) NOT NULL,
  `PASSWD` varchar(100) default NULL,
  `EMAIL` varchar(100) NOT NULL,
  PRIMARY KEY  (`ID`)
) ENGINE=InnoDB DEFAULT CHARSET=gbk;

#
# Structure for the `projectinfo` table : 
#

CREATE TABLE `projectinfo` (
  `ID` int(11) NOT NULL,
  `NAME` varchar(100) NOT NULL,
  `DESCRIPTION` varchar(500) default NULL,
  `MANAGER` int(11) NOT NULL,
  PRIMARY KEY  (`ID`),
  KEY `MANAGER` (`MANAGER`),
  CONSTRAINT `projectinfo_ibfk_1` FOREIGN KEY (`MANAGER`) REFERENCES `userinfo` (`ID`)
) ENGINE=InnoDB DEFAULT CHARSET=gbk;

#
# Structure for the `deployment` table : 
#

CREATE TABLE `deployment` (
  `ID` int(11) NOT NULL,
  `NAME` varchar(100) NOT NULL,
  `DESCRIPTION` varchar(500) default NULL,
  `STATUS_ID` int(11) NOT NULL,
  `CREATEBY` int(11) NOT NULL,
  `CREATETIME` datetime NOT NULL,
  `PROJ_ID` int(11) NOT NULL,
  PRIMARY KEY  (`ID`),
  KEY `CREATEBY` (`CREATEBY`),
  KEY `PROJ_ID` (`PROJ_ID`),
  CONSTRAINT `deployment_ibfk_1` FOREIGN KEY (`CREATEBY`) REFERENCES `userinfo` (`ID`),
  CONSTRAINT `deployment_ibfk_2` FOREIGN KEY (`PROJ_ID`) REFERENCES `projectinfo` (`ID`)
) ENGINE=InnoDB DEFAULT CHARSET=gbk;

#
# Structure for the `check_data` table : 
#

CREATE TABLE `check_data` (
  `DEPLOY_ID` int(11) NOT NULL,
  `DATA` varchar(4000) NOT NULL,
  PRIMARY KEY  (`DEPLOY_ID`),
  CONSTRAINT `check_data_ibfk_1` FOREIGN KEY (`DEPLOY_ID`) REFERENCES `deployment` (`ID`)
) ENGINE=InnoDB DEFAULT CHARSET=gbk;

#
# Structure for the `dic_codecheck_status` table : 
#

CREATE TABLE `dic_codecheck_status` (
  `ID` int(11) NOT NULL,
  `NAME` varchar(100) NOT NULL,
  PRIMARY KEY  (`ID`)
) ENGINE=InnoDB DEFAULT CHARSET=gbk;

#
# Structure for the `dic_deploy_status` table : 
#

CREATE TABLE `dic_deploy_status` (
  `ID` int(11) NOT NULL,
  `NAME` varchar(100) NOT NULL,
  PRIMARY KEY  (`ID`)
) ENGINE=InnoDB DEFAULT CHARSET=gbk;

#
# Structure for the `dic_deploy_type` table : 
#

CREATE TABLE `dic_deploy_type` (
  `ID` int(11) NOT NULL,
  `NAME` varchar(100) NOT NULL,
  PRIMARY KEY  (`ID`)
) ENGINE=InnoDB DEFAULT CHARSET=gbk;

#
# Structure for the `dic_file_type` table : 
#

CREATE TABLE `dic_file_type` (
  `ID` int(11) NOT NULL,
  `NAME` varchar(100) NOT NULL,
  PRIMARY KEY  (`ID`)
) ENGINE=InnoDB DEFAULT CHARSET=gbk;

#
# Structure for the `fileinfo` table : 
#

CREATE TABLE `fileinfo` (
  `ID` int(11) NOT NULL,
  `DEPLOY_ID` int(11) NOT NULL,
  `FILE_TYPE_ID` int(11) default NULL,
  `NAME` varchar(100) NOT NULL,
  `ADDRESS` varchar(200) NOT NULL,
  `VERSION` int(11) NOT NULL,
  `DEPLOY_TYPE` int(11) default NULL,
  `PD` varchar(20) default NULL,
  `NOTES` varchar(500) default NULL,
  PRIMARY KEY  (`ID`),
  KEY `DEPLOY_ID` (`DEPLOY_ID`),
  CONSTRAINT `fileinfo_ibfk_1` FOREIGN KEY (`DEPLOY_ID`) REFERENCES `deployment` (`ID`)
) ENGINE=InnoDB DEFAULT CHARSET=gbk;

#
# Structure for the `file_check_info` table : 
#

CREATE TABLE `file_check_info` (
  `FILE_ID` int(11) NOT NULL,
  `STATUS_ID` int(11) NOT NULL,
  `CHECKER` int(11) NOT NULL,
  PRIMARY KEY  (`FILE_ID`),
  KEY `CHECKER` (`CHECKER`),
  CONSTRAINT `file_check_info_ibfk_1` FOREIGN KEY (`CHECKER`) REFERENCES `userinfo` (`ID`),
  CONSTRAINT `file_check_info_ibfk_2` FOREIGN KEY (`FILE_ID`) REFERENCES `fileinfo` (`ID`)
) ENGINE=InnoDB DEFAULT CHARSET=gbk;

#
# Structure for the `filedeploystatus` table : 
#

CREATE TABLE `filedeploystatus` (
  `FILE_ID` int(11) NOT NULL,
  `STATUS_ID` int(11) NOT NULL,
  `DEPLOYMEN` int(11) NOT NULL,
  PRIMARY KEY  (`FILE_ID`),
  KEY `DEPLOYMEN` (`DEPLOYMEN`),
  CONSTRAINT `filedeploystatus_ibfk_1` FOREIGN KEY (`FILE_ID`) REFERENCES `fileinfo` (`ID`),
  CONSTRAINT `filedeploystatus_ibfk_2` FOREIGN KEY (`DEPLOYMEN`) REFERENCES `userinfo` (`ID`)
) ENGINE=InnoDB DEFAULT CHARSET=gbk;

#
# Structure for the `menu` table : 
#

CREATE TABLE `menu` (
  `MENU_ID` int(11) NOT NULL,
  `PARENT_NAME` varchar(60) default NULL,
  `NAME` varchar(60) default NULL,
  `TITLE` varchar(60) default NULL,
  `DESCRIPTION` varchar(100) default NULL,
  `LOCATION` varchar(60) default NULL,
  `TARGET` varchar(20) default NULL,
  `ONCLICK` varchar(200) default NULL,
  `ONMOUSEOVER` varchar(20) default NULL,
  `ONMOUSEOUT` varchar(20) default NULL,
  `IMAGE` varchar(100) default NULL,
  `ALTIMAGE` varchar(60) default NULL,
  `TOOLTIP` varchar(200) default NULL,
  `ROLES` varchar(200) default NULL,
  `PAGE` varchar(60) default NULL,
  `WIDTH` varchar(10) default NULL,
  `HEIGHT` varchar(10) default NULL,
  `FORWARD` varchar(100) default NULL,
  `ACTION` varchar(100) default NULL,
  PRIMARY KEY  (`MENU_ID`)
) ENGINE=InnoDB DEFAULT CHARSET=gbk;

#
# Structure for the `roleinfo` table : 
#

CREATE TABLE `roleinfo` (
  `ID` int(11) NOT NULL,
  `NAME` varchar(100) NOT NULL,
  PRIMARY KEY  (`ID`)
) ENGINE=InnoDB DEFAULT CHARSET=gbk;

#
# Structure for the `rolemenu` table : 
#

CREATE TABLE `rolemenu` (
  `ROLE_ID` int(11) default NULL,
  `MENU_ID` int(11) default NULL,
  KEY `MENU_ID` (`MENU_ID`),
  CONSTRAINT `rolemenu_ibfk_1` FOREIGN KEY (`MENU_ID`) REFERENCES `menu` (`MENU_ID`)
) ENGINE=InnoDB DEFAULT CHARSET=gbk;

#
# Structure for the `user_role_rational` table : 
#

CREATE TABLE `user_role_rational` (
  `USER_ID` int(11) NOT NULL,
  `ROLE_ID` int(11) NOT NULL,
  PRIMARY KEY  (`USER_ID`,`ROLE_ID`),
  KEY `ROLE_ID` (`ROLE_ID`),
  CONSTRAINT `user_role_rational_ibfk_1` FOREIGN KEY (`USER_ID`) REFERENCES `userinfo` (`ID`),
  CONSTRAINT `user_role_rational_ibfk_2` FOREIGN KEY (`ROLE_ID`) REFERENCES `roleinfo` (`ID`)
) ENGINE=InnoDB DEFAULT CHARSET=gbk;



/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;