package com.wonders.dao;

import java.util.List;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.hibernate.LockMode;
import org.hibernate.Query;
import org.hibernate.criterion.Example;

/**
 * Data access object (DAO) for domain model class CheckData.
 * @see com.wonders.dao.CheckData
 * @author MyEclipse - Hibernate Tools
 */
public class CheckDataDAO extends BaseHibernateDAO {

    private static final Log log = LogFactory.getLog(CheckDataDAO.class);

	//property constants
	public static final String DATA = "data";

    
    public void save(CheckData transientInstance) {
        log.debug("saving CheckData instance");
        try {
            getSession().save(transientInstance);
            log.debug("save successful");
        } catch (RuntimeException re) {
            log.error("save failed", re);
            throw re;
        }
    }
    
	public void delete(CheckData persistentInstance) {
        log.debug("deleting CheckData instance");
        try {
            getSession().delete(persistentInstance);
            log.debug("delete successful");
        } catch (RuntimeException re) {
            log.error("delete failed", re);
            throw re;
        }
    }
    
    public CheckData findById( java.lang.Integer id) {
        log.debug("getting CheckData instance with id: " + id);
        try {
            CheckData instance = (CheckData) getSession()
                    .get("com.wonders.dao.CheckData", id);
            return instance;
        } catch (RuntimeException re) {
            log.error("get failed", re);
            throw re;
        }
    }
    
    
    public List findByExample(CheckData instance) {
        log.debug("finding CheckData instance by example");
        try {
            List results = getSession()
                    .createCriteria("com.wonders.dao.CheckData")
                    .add(Example.create(instance))
            .list();
            log.debug("find by example successful, result size: " + results.size());
            return results;
        } catch (RuntimeException re) {
            log.error("find by example failed", re);
            throw re;
        }
    }    
    
    public List findByProperty(String propertyName, Object value) {
      log.debug("finding CheckData instance with property: " + propertyName
            + ", value: " + value);
      try {
         String queryString = "from CheckData as model where model." 
         						+ propertyName + "= ?";
         Query queryObject = getSession().createQuery(queryString);
		 queryObject.setParameter(0, value);
		 return queryObject.list();
      } catch (RuntimeException re) {
         log.error("find by property name failed", re);
         throw re;
      }
	}

	public List findByData(Object data) {
		return findByProperty(DATA, data);
	}
	
    public CheckData merge(CheckData detachedInstance) {
        log.debug("merging CheckData instance");
        try {
            CheckData result = (CheckData) getSession()
                    .merge(detachedInstance);
            log.debug("merge successful");
            return result;
        } catch (RuntimeException re) {
            log.error("merge failed", re);
            throw re;
        }
    }

    public void attachDirty(CheckData instance) {
        log.debug("attaching dirty CheckData instance");
        try {
            getSession().saveOrUpdate(instance);
            log.debug("attach successful");
        } catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
    
    public void attachClean(CheckData instance) {
        log.debug("attaching clean CheckData instance");
        try {
            getSession().lock(instance, LockMode.NONE);
            log.debug("attach successful");
        } catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
}