package com.wonders.dao;

import java.util.Date;
import java.util.List;
import java.util.Set;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.hibernate.LockMode;
import org.hibernate.Query;
import org.hibernate.criterion.Example;

/**
 * Data access object (DAO) for domain model class Deployment.
 * @see com.wonders.dao.Deployment
 * @author MyEclipse - Hibernate Tools
 */
public class DeploymentDAO extends BaseHibernateDAO {

    private static final Log log = LogFactory.getLog(DeploymentDAO.class);

	//property constants
	public static final String NAME = "name";
	public static final String DESCRIPTION = "description";
	public static final String STATUS_ID = "statusId";

    
    public void save(Deployment transientInstance) {
        log.debug("saving Deployment instance");
        try {
            getSession().save(transientInstance);
            log.debug("save successful");
        } catch (RuntimeException re) {
            log.error("save failed", re);
            throw re;
        }
    }
    
	public void delete(Deployment persistentInstance) {
        log.debug("deleting Deployment instance");
        try {
            getSession().delete(persistentInstance);
            log.debug("delete successful");
        } catch (RuntimeException re) {
            log.error("delete failed", re);
            throw re;
        }
    }
    
    public Deployment findById( java.lang.Integer id) {
        log.debug("getting Deployment instance with id: " + id);
        try {
            Deployment instance = (Deployment) getSession()
                    .get("com.wonders.dao.Deployment", id);
            return instance;
        } catch (RuntimeException re) {
            log.error("get failed", re);
            throw re;
        }
    }
    
    
    public List findByExample(Deployment instance) {
        log.debug("finding Deployment instance by example");
        try {
            List results = getSession()
                    .createCriteria("com.wonders.dao.Deployment")
                    .add(Example.create(instance))
            .list();
            log.debug("find by example successful, result size: " + results.size());
            return results;
        } catch (RuntimeException re) {
            log.error("find by example failed", re);
            throw re;
        }
    }    
    
    public List findByProperty(String propertyName, Object value) {
      log.debug("finding Deployment instance with property: " + propertyName
            + ", value: " + value);
      try {
         String queryString = "from Deployment as model where model." 
         						+ propertyName + "= ?";
         Query queryObject = getSession().createQuery(queryString);
		 queryObject.setParameter(0, value);
		 return queryObject.list();
      } catch (RuntimeException re) {
         log.error("find by property name failed", re);
         throw re;
      }
	}

	public List findByName(Object name) {
		return findByProperty(NAME, name);
	}
	
	public List findByDescription(Object description) {
		return findByProperty(DESCRIPTION, description);
	}
	
	public List findByStatusId(Object statusId) {
		return findByProperty(STATUS_ID, statusId);
	}
	
    public Deployment merge(Deployment detachedInstance) {
        log.debug("merging Deployment instance");
        try {
            Deployment result = (Deployment) getSession()
                    .merge(detachedInstance);
            log.debug("merge successful");
            return result;
        } catch (RuntimeException re) {
            log.error("merge failed", re);
            throw re;
        }
    }

    public void attachDirty(Deployment instance) {
        log.debug("attaching dirty Deployment instance");
        try {
            getSession().saveOrUpdate(instance);
            log.debug("attach successful");
        } catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
    
    public void attachClean(Deployment instance) {
        log.debug("attaching clean Deployment instance");
        try {
            getSession().lock(instance, LockMode.NONE);
            log.debug("attach successful");
        } catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
    public List getAll(){
    	log.debug("finding all Deployment instance.");
          try {
             String queryString = "from Deployment";
             Query queryObject = getSession().createQuery(queryString);
    		 return queryObject.list();
          } catch (RuntimeException re) {
             log.error("find all deployment failed", re);
             throw re;
          }
    }
}