package com.wonders.dao;

import java.util.List;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.hibernate.LockMode;
import org.hibernate.Query;
import org.hibernate.criterion.Example;

/**
 * Data access object (DAO) for domain model class DicCodecheckStatus.
 * @see com.wonders.dao.DicCodecheckStatus
 * @author MyEclipse - Hibernate Tools
 */
public class DicCodecheckStatusDAO extends BaseHibernateDAO {

    private static final Log log = LogFactory.getLog(DicCodecheckStatusDAO.class);

	//property constants
	public static final String NAME = "name";

    
    public void save(DicCodecheckStatus transientInstance) {
        log.debug("saving DicCodecheckStatus instance");
        try {
            getSession().save(transientInstance);
            log.debug("save successful");
        } catch (RuntimeException re) {
            log.error("save failed", re);
            throw re;
        }
    }
    
	public void delete(DicCodecheckStatus persistentInstance) {
        log.debug("deleting DicCodecheckStatus instance");
        try {
            getSession().delete(persistentInstance);
            log.debug("delete successful");
        } catch (RuntimeException re) {
            log.error("delete failed", re);
            throw re;
        }
    }
    
    public DicCodecheckStatus findById( java.lang.Integer id) {
        log.debug("getting DicCodecheckStatus instance with id: " + id);
        try {
            DicCodecheckStatus instance = (DicCodecheckStatus) getSession()
                    .get("com.wonders.dao.DicCodecheckStatus", id);
            return instance;
        } catch (RuntimeException re) {
            log.error("get failed", re);
            throw re;
        }
    }
    
    
    public List findByExample(DicCodecheckStatus instance) {
        log.debug("finding DicCodecheckStatus instance by example");
        try {
            List results = getSession()
                    .createCriteria("com.wonders.dao.DicCodecheckStatus")
                    .add(Example.create(instance))
            .list();
            log.debug("find by example successful, result size: " + results.size());
            return results;
        } catch (RuntimeException re) {
            log.error("find by example failed", re);
            throw re;
        }
    }    
    
    public List findByProperty(String propertyName, Object value) {
      log.debug("finding DicCodecheckStatus instance with property: " + propertyName
            + ", value: " + value);
      try {
         String queryString = "from DicCodecheckStatus as model where model." 
         						+ propertyName + "= ?";
         Query queryObject = getSession().createQuery(queryString);
		 queryObject.setParameter(0, value);
		 return queryObject.list();
      } catch (RuntimeException re) {
         log.error("find by property name failed", re);
         throw re;
      }
	}

	public List findByName(Object name) {
		return findByProperty(NAME, name);
	}
	
    public DicCodecheckStatus merge(DicCodecheckStatus detachedInstance) {
        log.debug("merging DicCodecheckStatus instance");
        try {
            DicCodecheckStatus result = (DicCodecheckStatus) getSession()
                    .merge(detachedInstance);
            log.debug("merge successful");
            return result;
        } catch (RuntimeException re) {
            log.error("merge failed", re);
            throw re;
        }
    }

    public void attachDirty(DicCodecheckStatus instance) {
        log.debug("attaching dirty DicCodecheckStatus instance");
        try {
            getSession().saveOrUpdate(instance);
            log.debug("attach successful");
        } catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
    
    public void attachClean(DicCodecheckStatus instance) {
        log.debug("attaching clean DicCodecheckStatus instance");
        try {
            getSession().lock(instance, LockMode.NONE);
            log.debug("attach successful");
        } catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
}