package com.wonders.dao;

import java.util.List;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.hibernate.LockMode;
import org.hibernate.Query;
import org.hibernate.criterion.Example;

/**
 * Data access object (DAO) for domain model class DicDeployStatus.
 * @see com.wonders.dao.DicDeployStatus
 * @author MyEclipse - Hibernate Tools
 */
public class DicDeployStatusDAO extends BaseHibernateDAO {

    private static final Log log = LogFactory.getLog(DicDeployStatusDAO.class);

	//property constants
	public static final String NAME = "name";

    
    public void save(DicDeployStatus transientInstance) {
        log.debug("saving DicDeployStatus instance");
        try {
            getSession().save(transientInstance);
            log.debug("save successful");
        } catch (RuntimeException re) {
            log.error("save failed", re);
            throw re;
        }
    }
    
	public void delete(DicDeployStatus persistentInstance) {
        log.debug("deleting DicDeployStatus instance");
        try {
            getSession().delete(persistentInstance);
            log.debug("delete successful");
        } catch (RuntimeException re) {
            log.error("delete failed", re);
            throw re;
        }
    }
    
    public DicDeployStatus findById( java.lang.Integer id) {
        log.debug("getting DicDeployStatus instance with id: " + id);
        try {
            DicDeployStatus instance = (DicDeployStatus) getSession()
                    .get("com.wonders.dao.DicDeployStatus", id);
            return instance;
        } catch (RuntimeException re) {
            log.error("get failed", re);
            throw re;
        }
    }
    
    
    public List findByExample(DicDeployStatus instance) {
        log.debug("finding DicDeployStatus instance by example");
        try {
            List results = getSession()
                    .createCriteria("com.wonders.dao.DicDeployStatus")
                    .add(Example.create(instance))
            .list();
            log.debug("find by example successful, result size: " + results.size());
            return results;
        } catch (RuntimeException re) {
            log.error("find by example failed", re);
            throw re;
        }
    }    
    
    public List findByProperty(String propertyName, Object value) {
      log.debug("finding DicDeployStatus instance with property: " + propertyName
            + ", value: " + value);
      try {
         String queryString = "from DicDeployStatus as model where model." 
         						+ propertyName + "= ?";
         Query queryObject = getSession().createQuery(queryString);
		 queryObject.setParameter(0, value);
		 return queryObject.list();
      } catch (RuntimeException re) {
         log.error("find by property name failed", re);
         throw re;
      }
	}

	public List findByName(Object name) {
		return findByProperty(NAME, name);
	}
	
    public DicDeployStatus merge(DicDeployStatus detachedInstance) {
        log.debug("merging DicDeployStatus instance");
        try {
            DicDeployStatus result = (DicDeployStatus) getSession()
                    .merge(detachedInstance);
            log.debug("merge successful");
            return result;
        } catch (RuntimeException re) {
            log.error("merge failed", re);
            throw re;
        }
    }

    public void attachDirty(DicDeployStatus instance) {
        log.debug("attaching dirty DicDeployStatus instance");
        try {
            getSession().saveOrUpdate(instance);
            log.debug("attach successful");
        } catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
    
    public void attachClean(DicDeployStatus instance) {
        log.debug("attaching clean DicDeployStatus instance");
        try {
            getSession().lock(instance, LockMode.NONE);
            log.debug("attach successful");
        } catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
}