package com.wonders.dao;

import java.util.List;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.hibernate.LockMode;
import org.hibernate.Query;
import org.hibernate.criterion.Example;

/**
 * Data access object (DAO) for domain model class DicDeployType.
 * @see com.wonders.dao.DicDeployType
 * @author MyEclipse - Hibernate Tools
 */
public class DicDeployTypeDAO extends BaseHibernateDAO {

    private static final Log log = LogFactory.getLog(DicDeployTypeDAO.class);

	//property constants
	public static final String NAME = "name";

    
    public void save(DicDeployType transientInstance) {
        log.debug("saving DicDeployType instance");
        try {
            getSession().save(transientInstance);
            log.debug("save successful");
        } catch (RuntimeException re) {
            log.error("save failed", re);
            throw re;
        }
    }
    
	public void delete(DicDeployType persistentInstance) {
        log.debug("deleting DicDeployType instance");
        try {
            getSession().delete(persistentInstance);
            log.debug("delete successful");
        } catch (RuntimeException re) {
            log.error("delete failed", re);
            throw re;
        }
    }
    
    public DicDeployType findById( java.lang.Integer id) {
        log.debug("getting DicDeployType instance with id: " + id);
        try {
            DicDeployType instance = (DicDeployType) getSession()
                    .get("com.wonders.dao.DicDeployType", id);
            return instance;
        } catch (RuntimeException re) {
            log.error("get failed", re);
            throw re;
        }
    }
    
    
    public List findByExample(DicDeployType instance) {
        log.debug("finding DicDeployType instance by example");
        try {
            List results = getSession()
                    .createCriteria("com.wonders.dao.DicDeployType")
                    .add(Example.create(instance))
            .list();
            log.debug("find by example successful, result size: " + results.size());
            return results;
        } catch (RuntimeException re) {
            log.error("find by example failed", re);
            throw re;
        }
    }    
    
    public List findByProperty(String propertyName, Object value) {
      log.debug("finding DicDeployType instance with property: " + propertyName
            + ", value: " + value);
      try {
         String queryString = "from DicDeployType as model where model." 
         						+ propertyName + "= ?";
         Query queryObject = getSession().createQuery(queryString);
		 queryObject.setParameter(0, value);
		 return queryObject.list();
      } catch (RuntimeException re) {
         log.error("find by property name failed", re);
         throw re;
      }
	}

	public List findByName(Object name) {
		return findByProperty(NAME, name);
	}
	
    public DicDeployType merge(DicDeployType detachedInstance) {
        log.debug("merging DicDeployType instance");
        try {
            DicDeployType result = (DicDeployType) getSession()
                    .merge(detachedInstance);
            log.debug("merge successful");
            return result;
        } catch (RuntimeException re) {
            log.error("merge failed", re);
            throw re;
        }
    }

    public void attachDirty(DicDeployType instance) {
        log.debug("attaching dirty DicDeployType instance");
        try {
            getSession().saveOrUpdate(instance);
            log.debug("attach successful");
        } catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
    
    public void attachClean(DicDeployType instance) {
        log.debug("attaching clean DicDeployType instance");
        try {
            getSession().lock(instance, LockMode.NONE);
            log.debug("attach successful");
        } catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
}