package com.wonders.dao;

import java.util.List;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.hibernate.LockMode;
import org.hibernate.Query;
import org.hibernate.criterion.Example;

/**
 * Data access object (DAO) for domain model class DicFileType.
 * @see com.wonders.dao.DicFileType
 * @author MyEclipse - Hibernate Tools
 */
public class DicFileTypeDAO extends BaseHibernateDAO {

    private static final Log log = LogFactory.getLog(DicFileTypeDAO.class);

	//property constants
	public static final String NAME = "name";

    
    public void save(DicFileType transientInstance) {
        log.debug("saving DicFileType instance");
        try {
            getSession().save(transientInstance);
            log.debug("save successful");
        } catch (RuntimeException re) {
            log.error("save failed", re);
            throw re;
        }
    }
    
	public void delete(DicFileType persistentInstance) {
        log.debug("deleting DicFileType instance");
        try {
            getSession().delete(persistentInstance);
            log.debug("delete successful");
        } catch (RuntimeException re) {
            log.error("delete failed", re);
            throw re;
        }
    }
    
    public DicFileType findById( java.lang.Integer id) {
        log.debug("getting DicFileType instance with id: " + id);
        try {
            DicFileType instance = (DicFileType) getSession()
                    .get("com.wonders.dao.DicFileType", id);
            return instance;
        } catch (RuntimeException re) {
            log.error("get failed", re);
            throw re;
        }
    }
    
    
    public List findByExample(DicFileType instance) {
        log.debug("finding DicFileType instance by example");
        try {
            List results = getSession()
                    .createCriteria("com.wonders.dao.DicFileType")
                    .add(Example.create(instance))
            .list();
            log.debug("find by example successful, result size: " + results.size());
            return results;
        } catch (RuntimeException re) {
            log.error("find by example failed", re);
            throw re;
        }
    }    
    
    public List findByProperty(String propertyName, Object value) {
      log.debug("finding DicFileType instance with property: " + propertyName
            + ", value: " + value);
      try {
         String queryString = "from DicFileType as model where model." 
         						+ propertyName + "= ?";
         Query queryObject = getSession().createQuery(queryString);
		 queryObject.setParameter(0, value);
		 return queryObject.list();
      } catch (RuntimeException re) {
         log.error("find by property name failed", re);
         throw re;
      }
	}

	public List findByName(Object name) {
		return findByProperty(NAME, name);
	}
	
    public DicFileType merge(DicFileType detachedInstance) {
        log.debug("merging DicFileType instance");
        try {
            DicFileType result = (DicFileType) getSession()
                    .merge(detachedInstance);
            log.debug("merge successful");
            return result;
        } catch (RuntimeException re) {
            log.error("merge failed", re);
            throw re;
        }
    }

    public void attachDirty(DicFileType instance) {
        log.debug("attaching dirty DicFileType instance");
        try {
            getSession().saveOrUpdate(instance);
            log.debug("attach successful");
        } catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
    
    public void attachClean(DicFileType instance) {
        log.debug("attaching clean DicFileType instance");
        try {
            getSession().lock(instance, LockMode.NONE);
            log.debug("attach successful");
        } catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
}