package com.wonders.dao;

import java.util.List;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.hibernate.LockMode;
import org.hibernate.Query;
import org.hibernate.criterion.Example;

/**
 * Data access object (DAO) for domain model class FileCheckInfo.
 * @see com.wonders.dao.FileCheckInfo
 * @author MyEclipse - Hibernate Tools
 */
public class FileCheckInfoDAO extends BaseHibernateDAO {

    private static final Log log = LogFactory.getLog(FileCheckInfoDAO.class);

	//property constants
	public static final String STATUS_ID = "statusId";

    
    public void save(FileCheckInfo transientInstance) {
        log.debug("saving FileCheckInfo instance");
        try {
            getSession().save(transientInstance);
            log.debug("save successful");
        } catch (RuntimeException re) {
            log.error("save failed", re);
            throw re;
        }
    }
    
	public void delete(FileCheckInfo persistentInstance) {
        log.debug("deleting FileCheckInfo instance");
        try {
            getSession().delete(persistentInstance);
            log.debug("delete successful");
        } catch (RuntimeException re) {
            log.error("delete failed", re);
            throw re;
        }
    }
    
    public FileCheckInfo findById( java.lang.Integer id) {
        log.debug("getting FileCheckInfo instance with id: " + id);
        try {
            FileCheckInfo instance = (FileCheckInfo) getSession()
                    .get("com.wonders.dao.FileCheckInfo", id);
            return instance;
        } catch (RuntimeException re) {
            log.error("get failed", re);
            throw re;
        }
    }
    
    
    public List findByExample(FileCheckInfo instance) {
        log.debug("finding FileCheckInfo instance by example");
        try {
            List results = getSession()
                    .createCriteria("com.wonders.dao.FileCheckInfo")
                    .add(Example.create(instance))
            .list();
            log.debug("find by example successful, result size: " + results.size());
            return results;
        } catch (RuntimeException re) {
            log.error("find by example failed", re);
            throw re;
        }
    }    
    
    public List findByProperty(String propertyName, Object value) {
      log.debug("finding FileCheckInfo instance with property: " + propertyName
            + ", value: " + value);
      try {
         String queryString = "from FileCheckInfo as model where model." 
         						+ propertyName + "= ?";
         Query queryObject = getSession().createQuery(queryString);
		 queryObject.setParameter(0, value);
		 return queryObject.list();
      } catch (RuntimeException re) {
         log.error("find by property name failed", re);
         throw re;
      }
	}

	public List findByStatusId(Object statusId) {
		return findByProperty(STATUS_ID, statusId);
	}
	
    public FileCheckInfo merge(FileCheckInfo detachedInstance) {
        log.debug("merging FileCheckInfo instance");
        try {
            FileCheckInfo result = (FileCheckInfo) getSession()
                    .merge(detachedInstance);
            log.debug("merge successful");
            return result;
        } catch (RuntimeException re) {
            log.error("merge failed", re);
            throw re;
        }
    }

    public void attachDirty(FileCheckInfo instance) {
        log.debug("attaching dirty FileCheckInfo instance");
        try {
            getSession().saveOrUpdate(instance);
            log.debug("attach successful");
        } catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
    
    public void attachClean(FileCheckInfo instance) {
        log.debug("attaching clean FileCheckInfo instance");
        try {
            getSession().lock(instance, LockMode.NONE);
            log.debug("attach successful");
        } catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
}