package com.wonders.dao;

import java.util.List;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.hibernate.LockMode;
import org.hibernate.Query;
import org.hibernate.criterion.Example;

/**
 * Data access object (DAO) for domain model class Filedeploystatus.
 * @see com.wonders.dao.Filedeploystatus
 * @author MyEclipse - Hibernate Tools
 */
public class FiledeploystatusDAO extends BaseHibernateDAO {

    private static final Log log = LogFactory.getLog(FiledeploystatusDAO.class);

	//property constants
	public static final String STATUS_ID = "statusId";

    
    public void save(Filedeploystatus transientInstance) {
        log.debug("saving Filedeploystatus instance");
        try {
            getSession().save(transientInstance);
            log.debug("save successful");
        } catch (RuntimeException re) {
            log.error("save failed", re);
            throw re;
        }
    }
    
	public void delete(Filedeploystatus persistentInstance) {
        log.debug("deleting Filedeploystatus instance");
        try {
            getSession().delete(persistentInstance);
            log.debug("delete successful");
        } catch (RuntimeException re) {
            log.error("delete failed", re);
            throw re;
        }
    }
    
    public Filedeploystatus findById( java.lang.Integer id) {
        log.debug("getting Filedeploystatus instance with id: " + id);
        try {
            Filedeploystatus instance = (Filedeploystatus) getSession()
                    .get("com.wonders.dao.Filedeploystatus", id);
            return instance;
        } catch (RuntimeException re) {
            log.error("get failed", re);
            throw re;
        }
    }
    
    
    public List findByExample(Filedeploystatus instance) {
        log.debug("finding Filedeploystatus instance by example");
        try {
            List results = getSession()
                    .createCriteria("com.wonders.dao.Filedeploystatus")
                    .add(Example.create(instance))
            .list();
            log.debug("find by example successful, result size: " + results.size());
            return results;
        } catch (RuntimeException re) {
            log.error("find by example failed", re);
            throw re;
        }
    }    
    
    public List findByProperty(String propertyName, Object value) {
      log.debug("finding Filedeploystatus instance with property: " + propertyName
            + ", value: " + value);
      try {
         String queryString = "from Filedeploystatus as model where model." 
         						+ propertyName + "= ?";
         Query queryObject = getSession().createQuery(queryString);
		 queryObject.setParameter(0, value);
		 return queryObject.list();
      } catch (RuntimeException re) {
         log.error("find by property name failed", re);
         throw re;
      }
	}

	public List findByStatusId(Object statusId) {
		return findByProperty(STATUS_ID, statusId);
	}
	
    public Filedeploystatus merge(Filedeploystatus detachedInstance) {
        log.debug("merging Filedeploystatus instance");
        try {
            Filedeploystatus result = (Filedeploystatus) getSession()
                    .merge(detachedInstance);
            log.debug("merge successful");
            return result;
        } catch (RuntimeException re) {
            log.error("merge failed", re);
            throw re;
        }
    }

    public void attachDirty(Filedeploystatus instance) {
        log.debug("attaching dirty Filedeploystatus instance");
        try {
            getSession().saveOrUpdate(instance);
            log.debug("attach successful");
        } catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
    
    public void attachClean(Filedeploystatus instance) {
        log.debug("attaching clean Filedeploystatus instance");
        try {
            getSession().lock(instance, LockMode.NONE);
            log.debug("attach successful");
        } catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
}