package com.wonders.dao;

import java.util.List;
import java.util.Set;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.hibernate.LockMode;
import org.hibernate.Query;
import org.hibernate.criterion.Example;

/**
 * Data access object (DAO) for domain model class Fileinfo.
 * @see com.wonders.dao.Fileinfo
 * @author MyEclipse - Hibernate Tools
 */
public class FileinfoDAO extends BaseHibernateDAO {

    private static final Log log = LogFactory.getLog(FileinfoDAO.class);

	//property constants
	public static final String FILE_TYPE_ID = "fileTypeId";
	public static final String NAME = "name";
	public static final String ADDRESS = "address";
	public static final String VERSION = "version";
	public static final String DEPLOY_TYPE = "deployType";
	public static final String PD = "pd";
	public static final String NOTES = "notes";

    
    public void save(Fileinfo transientInstance) {
        log.debug("saving Fileinfo instance");
        try {
            getSession().save(transientInstance);
            log.debug("save successful");
        } catch (RuntimeException re) {
            log.error("save failed", re);
            throw re;
        }
    }
    
	public void delete(Fileinfo persistentInstance) {
        log.debug("deleting Fileinfo instance");
        try {
            getSession().delete(persistentInstance);
            log.debug("delete successful");
        } catch (RuntimeException re) {
            log.error("delete failed", re);
            throw re;
        }
    }
    
    public Fileinfo findById( java.lang.Integer id) {
        log.debug("getting Fileinfo instance with id: " + id);
        try {
            Fileinfo instance = (Fileinfo) getSession()
                    .get("com.wonders.dao.Fileinfo", id);
            return instance;
        } catch (RuntimeException re) {
            log.error("get failed", re);
            throw re;
        }
    }
    
    
    public List findByExample(Fileinfo instance) {
        log.debug("finding Fileinfo instance by example");
        try {
            List results = getSession()
                    .createCriteria("com.wonders.dao.Fileinfo")
                    .add(Example.create(instance))
            .list();
            log.debug("find by example successful, result size: " + results.size());
            return results;
        } catch (RuntimeException re) {
            log.error("find by example failed", re);
            throw re;
        }
    }    
    
    public List findByProperty(String propertyName, Object value) {
      log.debug("finding Fileinfo instance with property: " + propertyName
            + ", value: " + value);
      try {
         String queryString = "from Fileinfo as model where model." 
         						+ propertyName + "= ?";
         Query queryObject = getSession().createQuery(queryString);
		 queryObject.setParameter(0, value);
		 return queryObject.list();
      } catch (RuntimeException re) {
         log.error("find by property name failed", re);
         throw re;
      }
	}

	public List findByFileTypeId(Object fileTypeId) {
		return findByProperty(FILE_TYPE_ID, fileTypeId);
	}
	
	public List findByName(Object name) {
		return findByProperty(NAME, name);
	}
	
	public List findByAddress(Object address) {
		return findByProperty(ADDRESS, address);
	}
	
	public List findByVersion(Object version) {
		return findByProperty(VERSION, version);
	}
	
	public List findByDeployType(Object deployType) {
		return findByProperty(DEPLOY_TYPE, deployType);
	}
	
	public List findByPd(Object pd) {
		return findByProperty(PD, pd);
	}
	
	public List findByNotes(Object notes) {
		return findByProperty(NOTES, notes);
	}
	
    public Fileinfo merge(Fileinfo detachedInstance) {
        log.debug("merging Fileinfo instance");
        try {
            Fileinfo result = (Fileinfo) getSession()
                    .merge(detachedInstance);
            log.debug("merge successful");
            return result;
        } catch (RuntimeException re) {
            log.error("merge failed", re);
            throw re;
        }
    }

    public void attachDirty(Fileinfo instance) {
        log.debug("attaching dirty Fileinfo instance");
        try {
            getSession().saveOrUpdate(instance);
            log.debug("attach successful");
        } catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
    
    public void attachClean(Fileinfo instance) {
        log.debug("attaching clean Fileinfo instance");
        try {
            getSession().lock(instance, LockMode.NONE);
            log.debug("attach successful");
        } catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
}