package com.wonders.dao;

import java.util.List;
import java.util.Set;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.hibernate.LockMode;
import org.hibernate.Query;
import org.hibernate.criterion.Example;

/**
 * Data access object (DAO) for domain model class Menu.
 * @see com.wonders.dao.Menu
 * @author MyEclipse - Hibernate Tools
 */
public class MenuDAO extends BaseHibernateDAO {

    private static final Log log = LogFactory.getLog(MenuDAO.class);

	//property constants
	public static final String PARENT_NAME = "parentName";
	public static final String NAME = "name";
	public static final String TITLE = "title";
	public static final String DESCRIPTION = "description";
	public static final String LOCATION = "location";
	public static final String TARGET = "target";
	public static final String ONCLICK = "onclick";
	public static final String ONMOUSEOVER = "onmouseover";
	public static final String ONMOUSEOUT = "onmouseout";
	public static final String IMAGE = "image";
	public static final String ALTIMAGE = "altimage";
	public static final String TOOLTIP = "tooltip";
	public static final String ROLES = "roles";
	public static final String PAGE = "page";
	public static final String WIDTH = "width";
	public static final String HEIGHT = "height";
	public static final String FORWARD = "forward";
	public static final String ACTION = "action";

    
    public void save(Menu transientInstance) {
        log.debug("saving Menu instance");
        try {
            getSession().save(transientInstance);
            log.debug("save successful");
        } catch (RuntimeException re) {
            log.error("save failed", re);
            throw re;
        }
    }
    
	public void delete(Menu persistentInstance) {
        log.debug("deleting Menu instance");
        try {
            getSession().delete(persistentInstance);
            log.debug("delete successful");
        } catch (RuntimeException re) {
            log.error("delete failed", re);
            throw re;
        }
    }
    
    public Menu findById( java.lang.Integer id) {
        log.debug("getting Menu instance with id: " + id);
        try {
            Menu instance = (Menu) getSession()
                    .get("com.wonders.dao.Menu", id);
            return instance;
        } catch (RuntimeException re) {
            log.error("get failed", re);
            throw re;
        }
    }
    
    
    public List findByExample(Menu instance) {
        log.debug("finding Menu instance by example");
        try {
            List results = getSession()
                    .createCriteria("com.wonders.dao.Menu")
                    .add(Example.create(instance))
            .list();
            log.debug("find by example successful, result size: " + results.size());
            return results;
        } catch (RuntimeException re) {
            log.error("find by example failed", re);
            throw re;
        }
    }    
    
    public List findByProperty(String propertyName, Object value) {
      log.debug("finding Menu instance with property: " + propertyName
            + ", value: " + value);
      try {
         String queryString = "from Menu as model where model." 
         						+ propertyName + "= ?";
         Query queryObject = getSession().createQuery(queryString);
		 queryObject.setParameter(0, value);
		 return queryObject.list();
      } catch (RuntimeException re) {
         log.error("find by property name failed", re);
         throw re;
      }
	}

	public List findByParentName(Object parentName) {
		return findByProperty(PARENT_NAME, parentName);
	}
	
	public List findByName(Object name) {
		return findByProperty(NAME, name);
	}
	
	public List findByTitle(Object title) {
		return findByProperty(TITLE, title);
	}
	
	public List findByDescription(Object description) {
		return findByProperty(DESCRIPTION, description);
	}
	
	public List findByLocation(Object location) {
		return findByProperty(LOCATION, location);
	}
	
	public List findByTarget(Object target) {
		return findByProperty(TARGET, target);
	}
	
	public List findByOnclick(Object onclick) {
		return findByProperty(ONCLICK, onclick);
	}
	
	public List findByOnmouseover(Object onmouseover) {
		return findByProperty(ONMOUSEOVER, onmouseover);
	}
	
	public List findByOnmouseout(Object onmouseout) {
		return findByProperty(ONMOUSEOUT, onmouseout);
	}
	
	public List findByImage(Object image) {
		return findByProperty(IMAGE, image);
	}
	
	public List findByAltimage(Object altimage) {
		return findByProperty(ALTIMAGE, altimage);
	}
	
	public List findByTooltip(Object tooltip) {
		return findByProperty(TOOLTIP, tooltip);
	}
	
	public List findByRoles(Object roles) {
		return findByProperty(ROLES, roles);
	}
	
	public List findByPage(Object page) {
		return findByProperty(PAGE, page);
	}
	
	public List findByWidth(Object width) {
		return findByProperty(WIDTH, width);
	}
	
	public List findByHeight(Object height) {
		return findByProperty(HEIGHT, height);
	}
	
	public List findByForward(Object forward) {
		return findByProperty(FORWARD, forward);
	}
	
	public List findByAction(Object action) {
		return findByProperty(ACTION, action);
	}
	
    public Menu merge(Menu detachedInstance) {
        log.debug("merging Menu instance");
        try {
            Menu result = (Menu) getSession()
                    .merge(detachedInstance);
            log.debug("merge successful");
            return result;
        } catch (RuntimeException re) {
            log.error("merge failed", re);
            throw re;
        }
    }

    public void attachDirty(Menu instance) {
        log.debug("attaching dirty Menu instance");
        try {
            getSession().saveOrUpdate(instance);
            log.debug("attach successful");
        } catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
    
    public void attachClean(Menu instance) {
        log.debug("attaching clean Menu instance");
        try {
            getSession().lock(instance, LockMode.NONE);
            log.debug("attach successful");
        } catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
}