package com.wonders.dao;

import java.util.List;
import java.util.Set;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.hibernate.LockMode;
import org.hibernate.Query;
import org.hibernate.criterion.Example;

/**
 * Data access object (DAO) for domain model class Projectinfo.
 * @see com.wonders.dao.Projectinfo
 * @author MyEclipse - Hibernate Tools
 */
public class ProjectinfoDAO extends BaseHibernateDAO {

    private static final Log log = LogFactory.getLog(ProjectinfoDAO.class);

	//property constants
	public static final String NAME = "name";
	public static final String DESCRIPTION = "description";

    
    public void save(Projectinfo transientInstance) {
        log.debug("saving Projectinfo instance");
        try {
            getSession().save(transientInstance);
            log.debug("save successful");
        } catch (RuntimeException re) {
            log.error("save failed", re);
            throw re;
        }
    }
    
	public void delete(Projectinfo persistentInstance) {
        log.debug("deleting Projectinfo instance");
        try {
            getSession().delete(persistentInstance);
            log.debug("delete successful");
        } catch (RuntimeException re) {
            log.error("delete failed", re);
            throw re;
        }
    }
    
    public Projectinfo findById( java.lang.Integer id) {
        log.debug("getting Projectinfo instance with id: " + id);
        try {
            Projectinfo instance = (Projectinfo) getSession()
                    .get("com.wonders.dao.Projectinfo", id);
            return instance;
        } catch (RuntimeException re) {
            log.error("get failed", re);
            throw re;
        }
    }
    
    
    public List findByExample(Projectinfo instance) {
        log.debug("finding Projectinfo instance by example");
        try {
            List results = getSession()
                    .createCriteria("com.wonders.dao.Projectinfo")
                    .add(Example.create(instance))
            .list();
            log.debug("find by example successful, result size: " + results.size());
            return results;
        } catch (RuntimeException re) {
            log.error("find by example failed", re);
            throw re;
        }
    }    
    
    public List findByProperty(String propertyName, Object value) {
      log.debug("finding Projectinfo instance with property: " + propertyName
            + ", value: " + value);
      try {
         String queryString = "from Projectinfo as model where model." 
         						+ propertyName + "= ?";
         Query queryObject = getSession().createQuery(queryString);
		 queryObject.setParameter(0, value);
		 return queryObject.list();
      } catch (RuntimeException re) {
         log.error("find by property name failed", re);
         throw re;
      }
	}

	public List findByName(Object name) {
		return findByProperty(NAME, name);
	}
	
	public List findByDescription(Object description) {
		return findByProperty(DESCRIPTION, description);
	}
	
    public Projectinfo merge(Projectinfo detachedInstance) {
        log.debug("merging Projectinfo instance");
        try {
            Projectinfo result = (Projectinfo) getSession()
                    .merge(detachedInstance);
            log.debug("merge successful");
            return result;
        } catch (RuntimeException re) {
            log.error("merge failed", re);
            throw re;
        }
    }

    public void attachDirty(Projectinfo instance) {
        log.debug("attaching dirty Projectinfo instance");
        try {
            getSession().saveOrUpdate(instance);
            log.debug("attach successful");
        } catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
    
    public void attachClean(Projectinfo instance) {
        log.debug("attaching clean Projectinfo instance");
        try {
            getSession().lock(instance, LockMode.NONE);
            log.debug("attach successful");
        } catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
}