package com.wonders.dao;

import java.util.List;
import java.util.Set;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.hibernate.LockMode;
import org.hibernate.Query;
import org.hibernate.criterion.Example;

/**
 * Data access object (DAO) for domain model class Roleinfo.
 * @see com.wonders.dao.Roleinfo
 * @author MyEclipse - Hibernate Tools
 */
public class RoleinfoDAO extends BaseHibernateDAO {

    private static final Log log = LogFactory.getLog(RoleinfoDAO.class);

	//property constants
	public static final String NAME = "name";

    
    public void save(Roleinfo transientInstance) {
        log.debug("saving Roleinfo instance");
        try {
            getSession().save(transientInstance);
            log.debug("save successful");
        } catch (RuntimeException re) {
            log.error("save failed", re);
            throw re;
        }
    }
    
	public void delete(Roleinfo persistentInstance) {
        log.debug("deleting Roleinfo instance");
        try {
            getSession().delete(persistentInstance);
            log.debug("delete successful");
        } catch (RuntimeException re) {
            log.error("delete failed", re);
            throw re;
        }
    }
    
    public Roleinfo findById( java.lang.Integer id) {
        log.debug("getting Roleinfo instance with id: " + id);
        try {
            Roleinfo instance = (Roleinfo) getSession()
                    .get("com.wonders.dao.Roleinfo", id);
            return instance;
        } catch (RuntimeException re) {
            log.error("get failed", re);
            throw re;
        }
    }
    
    
    public List findByExample(Roleinfo instance) {
        log.debug("finding Roleinfo instance by example");
        try {
            List results = getSession()
                    .createCriteria("com.wonders.dao.Roleinfo")
                    .add(Example.create(instance))
            .list();
            log.debug("find by example successful, result size: " + results.size());
            return results;
        } catch (RuntimeException re) {
            log.error("find by example failed", re);
            throw re;
        }
    }    
    
    public List findByProperty(String propertyName, Object value) {
      log.debug("finding Roleinfo instance with property: " + propertyName
            + ", value: " + value);
      try {
         String queryString = "from Roleinfo as model where model." 
         						+ propertyName + "= ?";
         Query queryObject = getSession().createQuery(queryString);
		 queryObject.setParameter(0, value);
		 return queryObject.list();
      } catch (RuntimeException re) {
         log.error("find by property name failed", re);
         throw re;
      }
	}

	public List findByName(Object name) {
		return findByProperty(NAME, name);
	}
	
    public Roleinfo merge(Roleinfo detachedInstance) {
        log.debug("merging Roleinfo instance");
        try {
            Roleinfo result = (Roleinfo) getSession()
                    .merge(detachedInstance);
            log.debug("merge successful");
            return result;
        } catch (RuntimeException re) {
            log.error("merge failed", re);
            throw re;
        }
    }

    public void attachDirty(Roleinfo instance) {
        log.debug("attaching dirty Roleinfo instance");
        try {
            getSession().saveOrUpdate(instance);
            log.debug("attach successful");
        } catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
    
    public void attachClean(Roleinfo instance) {
        log.debug("attaching clean Roleinfo instance");
        try {
            getSession().lock(instance, LockMode.NONE);
            log.debug("attach successful");
        } catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
}