package com.wonders.dao;

import java.util.List;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.hibernate.LockMode;
import org.hibernate.Query;
import org.hibernate.criterion.Example;

/**
 * Data access object (DAO) for domain model class Rolemenu.
 * @see com.wonders.dao.Rolemenu
 * @author MyEclipse - Hibernate Tools
 */
public class RolemenuDAO extends BaseHibernateDAO {

    private static final Log log = LogFactory.getLog(RolemenuDAO.class);

	//property constants

    
    public void save(Rolemenu transientInstance) {
        log.debug("saving Rolemenu instance");
        try {
            getSession().save(transientInstance);
            log.debug("save successful");
        } catch (RuntimeException re) {
            log.error("save failed", re);
            throw re;
        }
    }
    
	public void delete(Rolemenu persistentInstance) {
        log.debug("deleting Rolemenu instance");
        try {
            getSession().delete(persistentInstance);
            log.debug("delete successful");
        } catch (RuntimeException re) {
            log.error("delete failed", re);
            throw re;
        }
    }
    
    public Rolemenu findById( com.wonders.dao.RolemenuId id) {
        log.debug("getting Rolemenu instance with id: " + id);
        try {
            Rolemenu instance = (Rolemenu) getSession()
                    .get("com.wonders.dao.Rolemenu", id);
            return instance;
        } catch (RuntimeException re) {
            log.error("get failed", re);
            throw re;
        }
    }
    
    
    public List findByExample(Rolemenu instance) {
        log.debug("finding Rolemenu instance by example");
        try {
            List results = getSession()
                    .createCriteria("com.wonders.dao.Rolemenu")
                    .add(Example.create(instance))
            .list();
            log.debug("find by example successful, result size: " + results.size());
            return results;
        } catch (RuntimeException re) {
            log.error("find by example failed", re);
            throw re;
        }
    }    
    
    public List findByProperty(String propertyName, Object value) {
      log.debug("finding Rolemenu instance with property: " + propertyName
            + ", value: " + value);
      try {
         String queryString = "from Rolemenu as model where model." 
         						+ propertyName + "= ?";
         Query queryObject = getSession().createQuery(queryString);
		 queryObject.setParameter(0, value);
		 return queryObject.list();
      } catch (RuntimeException re) {
         log.error("find by property name failed", re);
         throw re;
      }
	}

    public Rolemenu merge(Rolemenu detachedInstance) {
        log.debug("merging Rolemenu instance");
        try {
            Rolemenu result = (Rolemenu) getSession()
                    .merge(detachedInstance);
            log.debug("merge successful");
            return result;
        } catch (RuntimeException re) {
            log.error("merge failed", re);
            throw re;
        }
    }

    public void attachDirty(Rolemenu instance) {
        log.debug("attaching dirty Rolemenu instance");
        try {
            getSession().saveOrUpdate(instance);
            log.debug("attach successful");
        } catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
    
    public void attachClean(Rolemenu instance) {
        log.debug("attaching clean Rolemenu instance");
        try {
            getSession().lock(instance, LockMode.NONE);
            log.debug("attach successful");
        } catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
    public boolean isExist(int role_id,String name){
    	log.debug("checking if RoleMenu instance exists: role_id-" + role_id
                + ", menu_name-" + name);
          try {
             String queryString = "from Rolemenu as model join model.menu as menu join model.roleinfo as role where role.id=? and menu.name=?" ;
             Query queryObject = getSession().createQuery(queryString);
    		 queryObject.setInteger(0, role_id);
    		 queryObject.setString(1, name);
    		 if(queryObject.list().isEmpty()){
    			 return false;
    		 }
    		 else{
    			 return true;
    		 }
    		 
          } catch (RuntimeException re) {
             log.error("checking failed", re);
             throw re;
          }
    }
}