package com.wonders.dao;

import java.util.List;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.hibernate.LockMode;
import org.hibernate.Query;
import org.hibernate.criterion.Example;

/**
 * Data access object (DAO) for domain model class UserRoleRational.
 * @see com.wonders.dao.UserRoleRational
 * @author MyEclipse - Hibernate Tools
 */
public class UserRoleRationalDAO extends BaseHibernateDAO {

    private static final Log log = LogFactory.getLog(UserRoleRationalDAO.class);

	//property constants

    
    public void save(UserRoleRational transientInstance) {
        log.debug("saving UserRoleRational instance");
        try {
            getSession().save(transientInstance);
            log.debug("save successful");
        } catch (RuntimeException re) {
            log.error("save failed", re);
            throw re;
        }
    }
    
	public void delete(UserRoleRational persistentInstance) {
        log.debug("deleting UserRoleRational instance");
        try {
            getSession().delete(persistentInstance);
            log.debug("delete successful");
        } catch (RuntimeException re) {
            log.error("delete failed", re);
            throw re;
        }
    }
    
    public UserRoleRational findById( com.wonders.dao.UserRoleRationalId id) {
        log.debug("getting UserRoleRational instance with id: " + id);
        try {
            UserRoleRational instance = (UserRoleRational) getSession()
                    .get("com.wonders.dao.UserRoleRational", id);
            return instance;
        } catch (RuntimeException re) {
            log.error("get failed", re);
            throw re;
        }
    }
    
    
    public List findByExample(UserRoleRational instance) {
        log.debug("finding UserRoleRational instance by example");
        try {
            List results = getSession()
                    .createCriteria("com.wonders.dao.UserRoleRational")
                    .add(Example.create(instance))
            .list();
            log.debug("find by example successful, result size: " + results.size());
            return results;
        } catch (RuntimeException re) {
            log.error("find by example failed", re);
            throw re;
        }
    }    
    
    public List findByProperty(String propertyName, Object value) {
      log.debug("finding UserRoleRational instance with property: " + propertyName
            + ", value: " + value);
      try {
         String queryString = "from UserRoleRational as model where model." 
         						+ propertyName + "= ?";
         Query queryObject = getSession().createQuery(queryString);
		 queryObject.setParameter(0, value);
		 return queryObject.list();
      } catch (RuntimeException re) {
         log.error("find by property name failed", re);
         throw re;
      }
	}

    public UserRoleRational merge(UserRoleRational detachedInstance) {
        log.debug("merging UserRoleRational instance");
        try {
            UserRoleRational result = (UserRoleRational) getSession()
                    .merge(detachedInstance);
            log.debug("merge successful");
            return result;
        } catch (RuntimeException re) {
            log.error("merge failed", re);
            throw re;
        }
    }

    public void attachDirty(UserRoleRational instance) {
        log.debug("attaching dirty UserRoleRational instance");
        try {
            getSession().saveOrUpdate(instance);
            log.debug("attach successful");
        } catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
    
    public void attachClean(UserRoleRational instance) {
        log.debug("attaching clean UserRoleRational instance");
        try {
            getSession().lock(instance, LockMode.NONE);
            log.debug("attach successful");
        } catch (RuntimeException re) {
            log.error("attach failed", re);
            throw re;
        }
    }
}