package com.wonders.servlet;

import java.io.IOException;
import java.text.ParseException;
import java.text.SimpleDateFormat;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import com.wonders.dao.Deployment;
import com.wonders.dao.DeploymentDAO;
import com.wonders.dao.Userinfo;
import com.wonders.dao.UserinfoDAO;

public class InsertDeploymentServlet extends HttpServlet {
	private Log log = LogFactory.getLog(UpdateDeploymentServlet.class);
	/**
	 * Constructor of the object.
	 */
	public InsertDeploymentServlet() {
		super();
	}

	/**
	 * Destruction of the servlet. <br>
	 */
	public void destroy() {
		super.destroy(); // Just puts "destroy" string in log
		// Put your code here
	}

	/**
	 * The doGet method of the servlet. <br>
	 *
	 * This method is called when a form has its tag value method equals to get.
	 * 
	 * @param request the request send by the client to the server
	 * @param response the response send by the server to the client
	 * @throws ServletException if an error occurred
	 * @throws IOException if an error occurred
	 */
	public void doGet(HttpServletRequest request, HttpServletResponse response)
			throws ServletException, IOException {

		response.setContentType("text/xml;charset=UTF-8");
		response.setHeader("Cache-Control", "no-cache");
		String xml = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>";

		DeploymentDAO deployDAO = new DeploymentDAO();
		Deployment deploy = new Deployment();
		validate(deploy,request);
		deployDAO.save(deploy);
		xml += "<message><info>添加成功！</info></message>";
		response.getWriter().write(xml);
	}

	/**
	 * The doPost method of the servlet. <br>
	 *
	 * This method is called when a form has its tag value method equals to post.
	 * 
	 * @param request the request send by the client to the server
	 * @param response the response send by the server to the client
	 * @throws ServletException if an error occurred
	 * @throws IOException if an error occurred
	 */
	public void doPost(HttpServletRequest request, HttpServletResponse response)
			throws ServletException, IOException {

		doGet(request,response);
	}

	/**
	 * Initialization of the servlet. <br>
	 *
	 * @throws ServletException if an error occure
	 */
	public void init() throws ServletException {
		// Put your code here
	}
	public void validate(Deployment deploy, HttpServletRequest request) {
		deploy.setName(request.getParameter("name"));
		deploy.setDescription(request.getParameter("description"));

		
		String statusId = request.getParameter("statusId");
		if (!statusId.equals("") && (statusId != null))
			deploy.setStatusId(Integer.valueOf(statusId));
		else
			deploy.setStatusId(null);
		
		
		String createby = request.getParameter("createby");
		if (!createby.equals("") && (createby != null)){
			UserinfoDAO userDAO=new UserinfoDAO();
			Userinfo user=userDAO.findById(Integer.valueOf(createby));
			deploy.setUserinfo(user);}
		
		
		String createtime=request.getParameter("createtime");
		if(!createtime.equals("") && (createtime != null)){
		try {
			SimpleDateFormat format = new SimpleDateFormat();
			format.applyPattern("yyyy-MM-dd");
			deploy.setCreatetime(format.parse(createtime));

		} catch (ParseException e) {
			if (log.isErrorEnabled()) {
				log.error("日期格式不正确", e);
			}
		}}
		else{
			deploy.setCreatetime(null);
		}
		
	}
}
